unit KromUtils;
interface
uses math;

procedure krintersect(x1,y1,x2,y2,x3,y3:real; SizeX,SizeY:integer; var ot:array of integer);
function real2(c1,c2,c3,c4:char):real;
function unreal2(x:real):string;
function int2(c1,c2:char):LongInt; overload;
function int2(c1,c2,c3,c4:char):LongInt; overload;
function chr2(x,len:integer):string; overload;
function chr2(t:string; len:integer):string; overload;

implementation

procedure krintersect(x1,y1,x2,y2,x3,y3:real; SizeX,SizeY:integer; var ot:array of integer);
var Ax,Ay,Bx,By,Cx,Cy,v,w,t:real; i,k,j,g1,g2:integer;
begin i:=0;
x1:=x1/256; y1:=y1/256;
x2:=x2/256; y2:=y2/256;
x3:=x3/256; y3:=y3/256;
if x1<0 then x1:=0; if y1<0 then y1:=0; //Avoiding negative values
if x2<0 then x2:=0; if y2<0 then y2:=0; //
if x3<0 then x3:=0; if y3<0 then y3:=0; //

if x1>SizeX*4 then x1:=SizeX*4; if y1>=SizeY*4 then y1:=SizeY*4-0.001; //Avoiding out of range values
if x2>SizeX*4 then x2:=SizeX*4; if y2>=SizeY*4 then y2:=SizeY*4-0.001; //
if x3>SizeX*4 then x3:=SizeX*4; if y3>=SizeY*4 then y3:=SizeY*4-0.001; //

if y1>y2 then begin                            //Sorting highest
 if y1>y3 then begin Ax:=x1; Ay:=y1; end
          else begin Ax:=x3; Ay:=y3; end       //
end else begin                                 //
 if y2>y3 then begin Ax:=x2; Ay:=y2; end       //
          else begin Ax:=x3; Ay:=y3; end
end;

if (Ax=x1)and(Ay=y1) then if y2>y3 then begin Bx:=x2; By:=y2; Cx:=x3; Cy:=y3; end
                       else begin Bx:=x3; By:=y3; Cx:=x2; Cy:=y2; end;
if (Ax=x2)and(Ay=y2) then if y1>y3 then begin Bx:=x1; By:=y1; Cx:=x3; Cy:=y3; end
                       else begin Bx:=x3; By:=y3; Cx:=x1; Cy:=y1; end;
if (Ax=x3)and(Ay=y3) then if y1>y2 then begin Bx:=x1; By:=y1; Cx:=x2; Cy:=y2; end
                       else begin Bx:=x2; By:=y2; Cx:=x1; Cy:=y1; end;
//A-highest
//B-middle
//C-lowest
if (trunc(Ax)=trunc(Bx))and(trunc(Bx)=trunc(Cx))               //All in one block
and(trunc(Ay)=trunc(By))and(trunc(By)=trunc(Cy)) then begin
ot[0]:=ceil(Ax)+trunc(Ay)*SizeX*4;
exit; end;

if (Cy<>By)and(Cy<>Ay) then              //Below mid-line
for k:=trunc(Cy)+1 to trunc(By) do begin
v:=Cx+(k-Cy)*(Ax-Cx)/(Ay-Cy); w:=Cx+(k-Cy)*(Bx-Cx)/(By-Cy);
if v<w then begin t:=w; w:=v; v:=t; end; //Exchange to V > W
for j:=trunc(w) to trunc(v) do begin
g1:=j+1; g2:=k-1; if g2<0 then g2:=0;
if (g1<=SizeX*4)and(g2<SizeY*4) then begin ot[i]:=g1+g2*SizeX*4; inc(i); end;
end;
end;

v:=Bx; w:=Cx+(By-Cy)*(Ax-Cx)/(Ay-Cy);    //Mid-line
if v<w then begin t:=w; w:=v; v:=t; end; //Exchange to V > W
for j:=trunc(w) to trunc(v) do begin
g1:=j+1; g2:=trunc(By);
if (g1<=SizeX*4)and(g2<SizeY*4) then begin ot[i]:=g1+g2*SizeX*4; inc(i); end;
end;

if (Ay<>Cy)and(Ay<>By) then              //Above mid-line
for k:=trunc(By)+1 to trunc(Ay) do begin                      //ceil(By)
v:=Cx+(k-Cy)*(Ax-Cx)/(Ay-Cy); w:=Bx+(k-By)*(Ax-Bx)/(Ay-By);
if v<w then begin t:=w; w:=v; v:=t; end; //Exchange to V > W
for j:=trunc(w) to trunc(v) do begin
g1:=j+1; g2:=k;
if (g1<=SizeX*4)and(g2<SizeY*4) then begin ot[i]:=g1+g2*SizeX*4; inc(i); end;
end;
end;

end;


function real2(c1,c2,c3,c4:char):real;
var i,sign,exponent:integer; t,mantissa:real;
begin
if ord(c4) div 128 = 1 then Sign:=-1 else Sign:=1;
Exponent:=(ord(c4) mod 128)*2 + (ord(c3) div 128)-127;
Mantissa:=(ord(c3) mod 128)*65536+ord(c2)*256+ord(c1);
t:=(1+Mantissa/8388608)*Sign;
if Exponent=-127 then t:=0 else
if exponent>0 then for i:=1 to exponent do t:=t*2 else
if exponent<0 then for i:=-1 downto exponent do t:=t/2;
real2:=t;
end;

function unreal2(x:real):string;
var sign,mant,expo:integer;
begin
if x<0 then sign:=1 else sign:=0;
if x<>0 then begin
x:=abs(x); expo:=0;
if x>=2 then repeat                  //normalizes X
x:=x/2; expo:=expo+1;           //so it look like
until(x<2)              // 1.28758...
else if x<1 then repeat                  //
x:=x*2; expo:=expo-1;   //power of 2
until(x>=1)             //to use
else expo:=0;           //
mant:=round((x-1)*8388608); expo:=expo+127;
unreal2:=chr(mant)+chr(mant div 256)+chr((mant div 65536)+(expo mod 2)*128)+chr(expo div 2 + sign*128);
end else unreal2:=#0+#0+#0+#0;
end;

function int2(c1,c2:char):LongInt; overload;
begin int2:=ord(c1)+ord(c2)*256; end;

function int2(c1,c2,c3,c4:char):LongInt; overload;
begin int2:=ord(c1)+ord(c2)*256+ord(c3)*65536+ord(c4)*16777216; end;

function chr2(x,len:integer):string; overload;
var s:string; begin
s:=chr(x)+chr(x div 256)+chr(x div 65536)+chr(x div 16777216);
setlength(s,len); chr2:=s;
end;

function chr2(t:string; len:integer):string; overload;
var i:integer; begin
for i:=length(t) to len-1 do t:=t+#0;
setlength(t,len);
chr2:=t;
end;



end.
