unit Unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, KromUtils;
type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
  private     { Private declarations }
  public      { Public declarations }
  end;

var
  Form1: TForm1;
  f:file; //Input FRD file
  fo:textfile;      //Output LWO files
  x,y,z:array[1..64]of real; //sounds,light,temp
  c:array[1..8192] of char; //max File size
  h,i,j,k,l,m,a,ii,kk,k2,fpos:integer;
  bqty,aqty:integer; //block Qty
  pqty,sqty,nvroad,xobj,obj,snd,light:array[1..8192] of integer;
  objtype,objid:array[1..8192,1..64]of integer;
  lqty:array[1..8192,0..12] of integer;
  xpqty,xlqty:array[1..64]of integer;
  xyz:array[1..8192,1..3]of real;
  uv:array[1..8192,1..4,1..2]of byte;
  v:array[1..8192,1..4]of integer;
  surf,tname:array[1..8192]of integer;
  aex:boolean;
  extradat:array[1..16]of integer;
  frdname,s:string;
  res:string[4];
implementation  {$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
if not OpenDialog1.Execute then exit;
frdname:=OpenDialog1.FileName;
CreateDir('LWO'); //make output folder
assignfile(f,frdname); reset(f,1);
blockread(f,c,28);
blockread(f,c,8); bqty:=int2(c[1],c[2],c[3],c[4])+1;
aqty:=int2(c[5],c[6],c[7],c[8]);
memo1.Lines.Add('Parts='+inttostr(bqty));
for i:=1 to aqty do begin
blockread(f,c,84); //ignore this ?
end;

for i:=1 to bqty do begin
blockread(f,c,1512); //chunks descriptions
if i=4 then
s:=s;
pqty[i]:=int2(c[89],c[90]); //Point qty
for k:=1 to 11 do lqty[i,k]:=int2(c[k*4-3],c[k*4-2]); //poLy qty
nvroad[i]:=int2(c[1413],c[1414]);
xobj[i]:=int2(c[1449],c[1450]);
obj[i]:=int2(c[1457],c[1458]);
snd[i]:=int2(c[1465],c[1466]);
light[i]:=int2(c[1473],c[1474]);
end;

for j:=1 to bqty do begin //Separate nodes
for i:=1 to pqty[j] do begin
blockread(f,c,12); //X,Y,Z real
xyz[i,1]:=real2(c[1],c[2],c[3],c[4]);
xyz[i,2]:=real2(c[5],c[6],c[7],c[8]);
xyz[i,3]:=real2(c[9],c[10],c[11],c[12]);
end;

for i:=1 to pqty[j] do blockread(f,c,4); // Normals/shading

for i:=1 to nvroad[j] do blockread(f,c,24); //Vroad

for i:=1 to xobj[j] do blockread(f,c,20); //XObjects
for i:=1 to obj[j] do begin
blockread(f,c,4); //Objects
objtype[j,i]:=ord(c[3]);
objid[j,i]:=ord(c[4]);
if c[3]=#4 then blockread(f,c,16) else blockread(f,c,12);
end;
for i:=1 to obj[j] do if objtype[j,i]<>4 then blockread(f,c,4);


for i:=1 to snd[j] do begin blockread(f,c,16); //Sounds
x[i]:=int2(c[2],c[3],c[4],#0)/256; if x[i]>32768 then x[i]:=x[i]-65536;
y[i]:=int2(c[6],c[7],c[8],#0)/256; if y[i]>32768 then y[i]:=y[i]-65536;
z[i]:=int2(c[10],c[11],c[12],#0)/256; if z[i]>32768 then z[i]:=z[i]-65536;
memo1.Lines.Add('SoundSrc'+#9+floattostr(round(x[i]*1000)/1000)+#9+floattostr(round(y[i]*1000)/1000)+#9+floattostr(round(z[i]*1000)/1000)
+#9+'ID '+inttostr(int2(c[13],c[14],c[15],c[16])));
end;
for i:=1 to light[j] do begin blockread(f,c,16); //Sounds
x[i]:=int2(c[2],c[3],c[4],#0)/256; if x[i]>32768 then x[i]:=x[i]-65536;
y[i]:=int2(c[6],c[7],c[8],#0)/256; if y[i]>32768 then y[i]:=y[i]-65536;
z[i]:=int2(c[10],c[11],c[12],#0)/256; if z[i]>32768 then z[i]:=z[i]-65536;
memo1.Lines.Add('LightSrc'+#9+floattostr(round(x[i]*1000)/1000)+#9+floattostr(round(y[i]*1000)/1000)+#9+floattostr(round(z[i]*1000)/1000));
end;

for i:=1 to 8192 do begin surf[i]:=0; tname[i]:=0; end; //clearing arrays lame way :)

m:=1;                  l:=1;
for k:=1 to 11 do
case k of
5,7..10: for i:=1 to lqty[j,k] do begin
   blockread(f,c,13);   //High quality model,road lines,objects
   v[m,1]:=int2(c[1],c[2])+1;
   v[m,2]:=int2(c[3],c[4])+1;
   v[m,3]:=int2(c[5],c[6])+1;
   v[m,4]:=int2(c[7],c[8])+1;              //UV mapping base
   surf[m]:=(int2(c[9],c[10])+1)mod 2048;  //     >X>
   uv[m,1,1]:=1; uv[m,1,2]:=1;             //   2-----1
   uv[m,2,1]:=0; uv[m,2,2]:=1;             //   |     | ^
   uv[m,3,1]:=0; uv[m,3,2]:=0;             //   |     | Y
   uv[m,4,1]:=1; uv[m,4,2]:=0;             //   3-----4 ^
   if ord(c[11])>=32 then begin //mirror Y (flip)
   a:=uv[m,2,2]; uv[m,2,2]:=uv[m,3,2]; uv[m,3,2]:=a;
   a:=uv[m,1,2]; uv[m,1,2]:=uv[m,4,2]; uv[m,4,2]:=a; c[11]:=chr(ord(c[11])-32);
   end;
   if ord(c[11])>=16 then begin //mirror X (flip)
   a:=uv[m,1,1]; uv[m,1,1]:=uv[m,2,1]; uv[m,2,1]:=a;
   a:=uv[m,3,1]; uv[m,3,1]:=uv[m,4,1]; uv[m,4,1]:=a; c[11]:=chr(ord(c[11])-16);
   end;
   if ord(c[11])>=8  then begin  //rotate 180   (aka invert everything)
   uv[m,1,1]:=1-uv[m,1,1]; uv[m,1,2]:=1-uv[m,1,2];
   uv[m,2,1]:=1-uv[m,2,1]; uv[m,2,2]:=1-uv[m,2,2];
   uv[m,3,1]:=1-uv[m,3,1]; uv[m,3,2]:=1-uv[m,3,2];
   uv[m,4,1]:=1-uv[m,4,1]; uv[m,4,2]:=1-uv[m,4,2]; c[11]:=chr(ord(c[11])-8);
   end;
   if ord(c[11])>=4  then begin  //rotate 90
   uv[m,1,1]:=uv[m,1,1]; uv[m,1,2]:=1-uv[m,1,2];
   uv[m,2,1]:=1-uv[m,2,1]; uv[m,2,2]:=uv[m,2,2];
   uv[m,3,1]:=uv[m,3,1]; uv[m,3,2]:=1-uv[m,3,2];
   uv[m,4,1]:=1-uv[m,4,1]; uv[m,4,2]:=uv[m,4,2]; c[11]:=chr(ord(c[11])-4);
   end;
//   memo1.Lines.Add(inttostr(j)+'-'+inttostr(m)+'  '+inttostr(ord(c[11]))+'-'+inttostr(ord(c[12]))+'-'+inttostr(ord(c[13])));
   aex:=false;
   for h:=1 to l do if tname[h]=surf[m] then aex:=true;
   if not aex then begin tname[l]:=surf[m]; inc(l); end;
   inc(m);
   end;
else
for i:=1 to lqty[j,k] do blockread(f,c,13);   //Low quality model, skipping
end;
sqty[j]:=l-1;
lqty[j,0]:=m-1;

ii:=0; k2:=1;
for kk:=1 to 8 do begin //upto 8 chunks

repeat
fpos:=filepos(f); blockread(f,c,4); seek(f,fpos);  //read 4 upcoming bytes
if (c[1]=#3)and(c[2]+c[3]+c[4]=#0+#0+#0) then begin blockread(f,c,52);
extradat[1]:=int2(c[25],c[26]);
extradat[2]:=int2(c[33],c[34]);
extradat[3]:=int2(c[45],c[46]);
blockread(f,c,8);
extradat[4]:=int2(c[5],c[6]);
blockread(f,c,20*extradat[4]);
blockread(f,c,12*extradat[2]);
blockread(f,c,4*extradat[2]);
blockread(f,c,13*extradat[3]);
end;
if ((c[1]=#4)or(c[1]=#2))and(c[2]+c[3]+c[4]=#0+#0+#0) then begin
inc(ii);
blockread(f,c,52); //Header
x[ii]:=real2(c[13],c[14],c[15],c[16]);
y[ii]:=real2(c[17],c[18],c[19],c[20]);
z[ii]:=real2(c[21],c[22],c[23],c[24]);
//extradat[1]:=int2(c[25],c[26]);
xpqty[ii]:=int2(c[33],c[34]);
xlqty[ii]:=int2(c[45],c[46]);
end;
until(((c[1]<>#4)and(c[1]<>#2))or(c[2]+c[3]+c[4]<>#0+#0+#0)); //easy way :?

for k:=k2 to ii do begin //same again for additional objects
{if extradat[1]<>0 then begin
blockread(f,c,8);
extradat[4]:=int2(c[5],c[6]);
blockread(f,c,20*extradat[4]);
extradat[1]:=0;
end; }
 for i:=1 to xpqty[k] do begin
 blockread(f,c,12);
 xyz[i+pqty[j],1]:=real2(c[1],c[2],c[3],c[4])+x[k];
 xyz[i+pqty[j],2]:=real2(c[5],c[6],c[7],c[8])+y[k];
 xyz[i+pqty[j],3]:=real2(c[9],c[10],c[11],c[12])+z[k];
 end;
blockread(f,c,xpqty[k]*4);
 for i:=1 to xlqty[k] do begin
 blockread(f,c,13);
 v[m,1]:=int2(c[1],c[2])+1+pqty[j];
 v[m,2]:=int2(c[3],c[4])+1+pqty[j];
 v[m,3]:=int2(c[5],c[6])+1+pqty[j];
 v[m,4]:=int2(c[7],c[8])+1+pqty[j];
   surf[m]:=(int2(c[9],c[10])+1)mod 2048;  //     >X>
   uv[m,1,1]:=1; uv[m,1,2]:=1;             //   2-----1
   uv[m,2,1]:=0; uv[m,2,2]:=1;             //   |     | ^
   uv[m,3,1]:=0; uv[m,3,2]:=0;             //   |     | Y
   uv[m,4,1]:=1; uv[m,4,2]:=0;             //   3-----4 ^
   if ord(c[11])>=32 then begin //mirror Y (flip)
   a:=uv[m,2,2]; uv[m,2,2]:=uv[m,3,2]; uv[m,3,2]:=a;
   a:=uv[m,1,2]; uv[m,1,2]:=uv[m,4,2]; uv[m,4,2]:=a; c[11]:=chr(ord(c[11])-32);
   end;
   if ord(c[11])>=16 then begin //mirror X (flip)
   a:=uv[m,1,1]; uv[m,1,1]:=uv[m,2,1]; uv[m,2,1]:=a;
   a:=uv[m,3,1]; uv[m,3,1]:=uv[m,4,1]; uv[m,4,1]:=a; c[11]:=chr(ord(c[11])-16);
   end;
   if ord(c[11])>=8  then begin  //rotate 180   (aka invert everything)
   uv[m,1,1]:=1-uv[m,1,1]; uv[m,1,2]:=1-uv[m,1,2];
   uv[m,2,1]:=1-uv[m,2,1]; uv[m,2,2]:=1-uv[m,2,2];
   uv[m,3,1]:=1-uv[m,3,1]; uv[m,3,2]:=1-uv[m,3,2];
   uv[m,4,1]:=1-uv[m,4,1]; uv[m,4,2]:=1-uv[m,4,2]; c[11]:=chr(ord(c[11])-8);
   end;
   if ord(c[11])>=4  then begin  //rotate 90
   uv[m,1,1]:=uv[m,1,1]; uv[m,1,2]:=1-uv[m,1,2];
   uv[m,2,1]:=1-uv[m,2,1]; uv[m,2,2]:=uv[m,2,2];
   uv[m,3,1]:=uv[m,3,1]; uv[m,3,2]:=1-uv[m,3,2];
   uv[m,4,1]:=1-uv[m,4,1]; uv[m,4,2]:=uv[m,4,2]; c[11]:=chr(ord(c[11])-4);
   end;
   aex:=false;
   for h:=1 to l do if tname[h]=surf[m] then aex:=true;
   if not aex then begin tname[l]:=surf[m]; inc(l); end;
 inc(m);
 end;
pqty[j]:=pqty[j]+xpqty[k];
lqty[j,0]:=m-1;
sqty[j]:=l-1;
end;
k2:=ii+1;
end;

for i:=1 to lqty[j,0] do begin
k:=0;
repeat
inc(k);
until(surf[i]=tname[k]);
surf[i]:=k;
end;

//==================================================================
//LWO Builder
//==================================================================
//memo1.Lines.Add('Writing LWO files');

s:='lwo\';
if j<10 then AssignFile(fo,s+'000'+inttostr(j)+'.lwo') else
if j<100 then AssignFile(fo,s+'00'+inttostr(j)+'.lwo') else
if j<1000 then AssignFile(fo,s+'0'+inttostr(j)+'.lwo') else
                AssignFile(fo,s+   inttostr(j)+'.lwo');      //LWO file name - ID

Rewrite(fo);
write(fo,'FORM'); m:=0; //computing chunksize
m:=m+12;                                  //+'LWO2TAGS   2'
m:=m+10*sqty[j];                             //+Surfaces
m:=m+8+18;                                //+LAYR_
m:=m+8+pqty[j]*12;                           //+PNTS+3D
m:=m+12+lqty[j,0]*10;                           //+Face 4.x.x.x.x
m:=m+12+lqty[j,0]*4;                           //+Surface
m:=m+14+10+lqty[j,0]*4*12;                     //+VMAD

for k:=1 to sqty[j] do
m:=m+8+10+(8+2)+2;                         //+CLIP+STIL+name+path
                  //always ****.xxx__
m:=m+(8+56+22+252 + 8)*sqty[j];                                     //+SURF Data

write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,'LWO2','TAGS');
write(fo,#0,#0,chr(sqty[j]*10 div 256),chr(sqty[j]*10));
//Names Length
for k:=1 to sqty[j] do write(fo,'Surf__',inttostr(tname[k]div 100),inttostr(tname[k]mod 100 div 10),inttostr(tname[k]mod 10),#0);                        //10chars

write(fo,'LAYR',#0,#0,#0,#18);
for k:=1 to 18 do write(fo,#0);    //layer name could be instead of 0`s

write(fo,'PNTS'); //Points
m:=pqty[j]*12; write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
for i:=1 to pqty[j] do begin
res:=unreal2(xyz[i,1]); write(fo,res[4],res[3],res[2],res[1]); //LWO uses
res:=unreal2(xyz[i,2]); write(fo,res[4],res[3],res[2],res[1]); //reverse
res:=unreal2(xyz[i,3]); write(fo,res[4],res[3],res[2],res[1]); //order
end;

write(fo,'POLS'); //Polygons
m:=lqty[j,0]*10+4; write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,'FACE');
for i:=1 to lqty[j,0] do begin
write(fo,#0,#4); // always 4 Points/Polygon for NFS3/4
write(fo
,chr((v[i,4]-1) div 256),chr(v[i,4]-1)
,chr((v[i,3]-1) div 256),chr(v[i,3]-1)
,chr((v[i,2]-1) div 256),chr(v[i,2]-1)
,chr((v[i,1]-1) div 256),chr(v[i,1]-1));
end;

write(fo,'PTAG'); //surface tag
m:=lqty[j,0]*4+4; write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,'SURF'); k:=0;
for i:=0 to lqty[j,0]-1 do begin
write(fo,chr(i div 256),chr(i),chr((surf[i+1]-1) div 256),chr(surf[i+1]-1));
end;

write(fo,'VMAD'); //UV map
m:=6+10+lqty[j,0]*4*12; write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,'TXUV',#0,#2,'Texture01',#0);
for i:=1 to lqty[j,0] do
 for h:=1 to 4 do begin
write(fo,chr((v[i,h]-1)div 256),chr(v[i,h]-1));
write(fo,chr((i-1) div 256),chr(i-1));
res:=unreal2(uv[i,h,1]); write(fo,res[4],res[3],res[2],res[1]);
res:=unreal2(uv[i,h,2]); write(fo,res[4],res[3],res[2],res[1]);
end;

for h:=1 to sqty[j] do begin
write(fo,'CLIP'); //texture file reference
m:=10+(8+2)+2; write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,#0,#0,#0,chr(h));
write(fo,'STIL'); m:=m-10; write(fo,chr(m div 256),chr(m));
write(fo,'0'+inttostr(tname[h]div 100)+inttostr(tname[h]mod 100 div 10)+inttostr(tname[h]mod 10)+'.bmp');
write(fo,#0,#0,#0,#0);
end;

for k:=1 to sqty[j] do begin
write(fo,'SURF'); //surface properties
m:=56+22+252 + 8;//DoubleSided      ////Data Len
write(fo,chr(m div 1677216),chr(m div 65536),chr(m div 256),chr(m));
write(fo,'Surf__',inttostr(tname[k]div 100),inttostr(tname[k]mod 100 div 10),inttostr(tname[k]mod 10),#0);                        //10chars
write(fo,#0,#0);
write(fo,'COLR',#0,#14);
res:=unreal2((random(192)+32)/256); write(fo,res[4],res[3],res[2],res[1]);
res:=unreal2((random(192)+32)/256); write(fo,res[4],res[3],res[2],res[1]);
res:=unreal2((random(192)+32)/256); write(fo,res[4],res[3],res[2],res[1]);

write(fo,#0,#0);
write(fo,'SPEC',#0,#6);
res:=unreal2(0); write(fo,res[4],res[3],res[2],res[1]);
write(fo,#0,#0);

write(fo,'REFL',#0,#6);
res:=unreal2(0); write(fo,res[4],res[3],res[2],res[1]);
write(fo,#0,#0);

write(fo,'TRAN',#0,#6);
res:=unreal2(0); write(fo,res[4],res[3],res[2],res[1]);
write(fo,#0,#0);

write(fo,'SMAN',#0,#4);
write(fo,#63,#200,#3,#14);

write(fo,'SIDE',#0,#2);
write(fo,#0,#3);

write(fo,'BLOK');
m:=246;      ////Depends.. 252-6
write(fo,chr(m div 256),chr(m));
write(fo,'IMAP',#0,'*A',#0,'CHAN',#0,#4,'COLROPAC',#0,#8,#0,#0,#63,#128,#0,#0,#0,#0);
write(fo,'ENAB',#0,#2,#0,#1,'NEGA',#0,#2,#0,#0,'TMAP',#0,#98,'CNTR',#0,#14); for i:=1 to 14 do write(fo,#0);
write(fo,'SIZE',#0,#14); for i:=1 to 3 do write(fo,#63,#128,#0,#0); write(fo,#0,#0);
write(fo,'ROTA',#0,#14); for i:=1 to 14 do write(fo,#0);
write(fo,'FALL',#0,#16); for i:=1 to 16 do write(fo,#0);
write(fo,'OREF',#0,#2,#0,#0,'CSYS',#0,#2,#0,#0,'PROJ',#0,#2,#0,#5,'AXIS',#0,#2,#0,#2);
write(fo,'IMAG',#0,#2,#0,chr(k),'WRAP',#0,#4,#0,#1,#0,#1,'WRPW',#0,#6,#63,#128,#0,#0,#0,#0);
//chr(k) - texture to use
write(fo,'WRPH',#0,#6,#63,#128,#0,#0,#0,#0,'VMAP',#0,#10,'Texture01',#0);
write(fo,'AAST',#0,#6,#0,#0,#63,#128,#0,#0,'PIXB',#0,#2,#0,#1);
end;

closefile(fo);
end; //one Node
fpos:=filepos(f);
closefile(f);
memo1.Lines.Add('Conversion complete, please exit.');
Button1.Enabled:=false;
end;

end.

